<?php
class hikashopCartHelper{
	function displayButton($name,$map,&$params,$url='',$ajax="",$options="",$max_quantity=0){
		$config =& hikashop::config();
		$button = $config->get('button_style','normal');
		$html = '';
		static $i=0;
		$i++;
		if(!empty($ajax)){
			$ajax = 'onclick="var field=document.getElementById(\'hikashop_product_quantity_field_'.$i.'\');'.$ajax.'" ';
		}
		switch($button){
			case 'rounded':
				$params->set('main_div_name', 'hikashop_button_'.$i);
				$moduleHelper = hikashop::get('helper.module');
				$moduleHelper->setCSS($params);
				$url = 'href="'.$url.'" ';
				$html.='
				<div id="'.$params->get('main_div_name').'">
				<div class="hikashop_container">
				<div class="hikashop_subcontainer">
				<a '.$url.$ajax.$options.'>'.$name.'</a>
				</div>
				</div>
				</div>
				';
				break;
			case 'css':
				$url = 'href="'.$url.'" ';
				$html.= '<a class="hikashop_cart_button" '.$url.$ajax.$options.'>'.$name.'</a>';
				break;
			case 'normal':
			default:
				
				$html.= '<input type="submit" class="button" name="'.$map.'" value="'.$name.'" '.$ajax.$options.'/>';
				break;
		}
		
		if($params->get('show_quantity_field',0)==1){
			$max_quantity=(int)$max_quantity;
			static $first = false;
			if(!$first){
				$first=true;
				$js = '
				function hikashopQuantityChange(field,plus,max){
					var fieldEl=document.getElementById(field);
					
					if(plus){
						var current = parseInt(fieldEl.value);
						if(max==0 || current<max){
							fieldEl.value=parseInt(fieldEl.value)+1;
						}
					}else{
						fieldEl.value=parseInt(fieldEl.value)-1;
					}
					return false;
				}
				';
				$doc =& JFactory::getDocument();
				$doc->addScriptDeclaration($js);
			}
			
			$html ='
			<table>
				<tr>
					<td rowspan="2">
						<input id="hikashop_product_quantity_field_'.$i.'" type="text" value="'.JRequest::getInt('quantity',1).'" class="hikashop_product_quantity_field" name="quantity" />
					</td>
					<td>
						<a id="hikashop_product_quantity_field_change_plus" class="hikashop_product_quantity_field_change" href="#" onclick="return hikashopQuantityChange(\'hikashop_product_quantity_field_'.$i.'\',1,'.$max_quantity.');">+</a>
					</td>
					<td rowspan="2">
						'.$html.'
					</td>
				</tr>
				<tr>
					<td>
						<a id="hikashop_product_quantity_field_change_minus" class="hikashop_product_quantity_field_change" href="#" onclick="return hikashopQuantityChange(\'hikashop_product_quantity_field_'.$i.'\',0);">-</a>
					</td>
				</tr>
			</table>	
			';
		}elseif($params->get('show_quantity_field',0)!=-1){
			$html.='<input id="hikashop_product_quantity_field_'.$i.'" type="hidden" value="1" class="hikashop_product_quantity_field" name="quantity" />';
		}
		
		return $html;
	}
	
	function cartCount($add=false){
		static $carts = 0;
		if($add){
			$carts=$carts+1;
		}
		return $carts;
	}
	
	function getJS($url){
		
//		switch($this->cartCount()){
//			case 1:
//				
				static $first = true;
				if($first){
					$config =& hikashop::config();
					$redirect = $config->get('redirect_url_after_add_cart','stay_if_cart');
					if($redirect=='ask_user'){
						JHTML::_('behavior.modal');
						if(JRequest::getVar('tmpl','')!='component'){
							jimport('joomla.html.parameter');
							$params=new JParameter('');
							global $Itemid;
							$url_itemid='';
							if(!empty($Itemid)){
								$url_itemid='&Itemid='.$Itemid;
							}
							echo '<div style="display:none;"><div id="hikashop_notice_box_content" name="hikashop_notice_box_content" ><div id="hikashop_notice_box_message" >'.hikashop::display(JText::_('PRODCUT_SUCCESSFULLY_ADDED_TO_CART'),'success',true).'</div><br /><div id="hikashop_add_to_cart_continue_div">'.
							$this->displayButton(JText::_('CONTINUE_SHOPPING'),'continue_shopping',$params,'','try{	window.top.document.getElementById(\'sbox-window\').close(); }catch(err){ window.top.SqueezeBox.close(); } return false;','id="hikashop_add_to_cart_continue_button"').'</div><div id="hikashop_add_to_cart_checkout_div">'.
							$this->displayButton(JText::_('PROCEED_TO_CHECKOUT'),'to_checkout',$params,hikashop::completeLink('checkout'.$url_itemid),'window.location=\''.hikashop::completeLink('checkout'.$url_itemid).'\';return false;','id="hikashop_add_to_cart_checkout_button"').'</div></div></div>';
						}
						$js = '
						function hikashopModifyQuantity(id,obj,add){
							if(add){
								add=\'&add=1\';
							}else{
								add=\'\';
							}
							if(obj){
								qty=parseInt(obj.value);
							}else{
								qty=1;
							}
							
							try{
								new Ajax(\''.JURI::base(true).'/index.php?option='.HIKASHOP_COMPONENT.'&tmpl=component&ctrl=product&task=updatecart&product_id=\'+id+\'&quantity=\'+qty+add+\'&url='.$url.'\',  { method: \'get\', onComplete: function(result) { var hikaModule = window.document.getElementById(\'hikashop_cart_module\'); if(hikaModule) hikaModule.innerHTML = result;}}).request();
							}catch(err){
								new Request({url:\''.JURI::base(true).'/index.php?option='.HIKASHOP_COMPONENT.'&tmpl=component&ctrl=product&task=updatecart&product_id=\'+id+\'&quantity=\'+qty+add+\'&url='.$url.'\', method: \'get\', onComplete: function(result) { var hikaModule = window.document.getElementById(\'hikashop_cart_module\'); if(hikaModule) hikaModule.innerHTML = result;}}).send();
							}
							
							//trigger the link
							if(qty){
								
								try{
									SqueezeBox.open($(\'hikashop_notice_box_content\'), {
										handler: \'adopt\',
										size: {x: 480, y: 120}
									});
								}catch(err){
									//create a link
									newlink = document.createElement(\'a\');  
									newlink.setAttribute(\'class\', \'modal\');
									newlink.setAttribute(\'rel\', \'{handler: \\\'adopt\\\',adopt:\\\'hikashop_notice_box_content\\\', size: {x: 480, y: 120}}\');
									SqueezeBox.fromElement(newlink);
								}
								setTimeout( \'try{	window.top.document.getElementById(\\\'sbox-window\\\').close(); }catch(err){ window.top.SqueezeBox.close(); }\', 3000 );
							}
							
							return false;
						}
						';
					}else{
						$js='';
						if($this->cartCount()!=1 && !empty($url)){
							$js = 'window.location = \''.urldecode($url).'\';';
						}
						$js = '
						function hikashopModifyQuantity(id,obj,add){
							if(add){
								add=\'&add=1\';
							}else{
								add=\'\';
							}
							if(obj){
								qty=parseInt(obj.value);
							}else{
								qty=1;
							}
							try{
								new Ajax(\''.JURI::base(true).'/index.php?option='.HIKASHOP_COMPONENT.'&tmpl=component&ctrl=product&task=updatecart&product_id=\'+id+\'&quantity=\'+qty+add+\'&url='.$url.'\',  { method: \'get\', onComplete: function(result) { var hikaModule = window.document.getElementById(\'hikashop_cart_module\'); if(hikaModule) hikaModule.innerHTML = result;'.$js.'}}).request();
							}catch(err){
								new Request({url:\''.JURI::base(true).'/index.php?option='.HIKASHOP_COMPONENT.'&tmpl=component&ctrl=product&task=updatecart&product_id=\'+id+\'&quantity=\'+qty+add+\'&url='.$url.'\', method: \'get\', onComplete: function(result) { var hikaModule = window.document.getElementById(\'hikashop_cart_module\'); if(hikaModule) hikaModule.innerHTML = result;'.$js.'}}).send();
							}
							
							return false;
						}
						';
						JHTML::_('behavior.mootools');
					}
					$doc =& JFactory::getDocument();
					$doc->addScriptDeclaration($js);
					$first = false;
				}
//				break;
//			case 0:
//			default:
//				static $second = 0;
//				if(empty($second) || $second==1){
//					$js = '
//						function hikashopModifyQuantity(id,obj,add){
//							var el = document.createElement("input");
//							el.type = "hidden";
//							el.name = "url";
//							el.value = "'.$url.'";
//							obj.form.appendChild(el);
//							obj.form.submit();
//							return false;
//						}
//					';
//					$doc =& JFactory::getDocument();
//					$doc->addScriptDeclaration($js);
//					$second++;
//				}
//				break;
//			
//		}
	}


}